package fr.nitorac.aurionweb.fragments.calendar;

import android.util.Log;
import android.webkit.WebView;
import android.widget.Toast;

import java.io.IOException;
import java.security.GeneralSecurityException;

import fr.nitorac.aurionweb.aurionweb.AurionManager;
import fr.nitorac.aurionweb.aurionweb.AurionSession;
import fr.nitorac.aurionweb.fragments.AurionViewFragment;
import fr.nitorac.aurionweb.fragments.home.HomeFragment;

public class CalendarFragment extends AurionViewFragment {

    public static final String AURION_CAL_URL = "https://aurionweb.ensiie.fr/faces/Planning.xhtml";
    private boolean failed = false;

    @Override
    public void pageFinished(WebView view, String url) {
        view.evaluateJavascript("$('#form\\\\:headerSubview\\\\:header,.divCurrentUser,.CardBigTopic,.EmptyBox20.cacherImpression').remove(); $('#layout-container').css('padding-top', '0rem'); $('.CardBigTopic').remove();", paRes -> {});
    }

    @Override
    public void networkInit(AurionSession session) {
        try {
            AurionManager.getInstance().reachMyEdtFromInit(currentSession);
        } catch (IOException | GeneralSecurityException e) {
            e.printStackTrace();
            failed = true;
            Log.e(getClass().getSimpleName(), "Impossible de charger le chemin vers l'emploi du temps (" + e.getLocalizedMessage() + ")");
            if(getActivity() != null){
                getActivity().runOnUiThread(() -> {
                    Toast.makeText(getContext(), "Impossible de charger le chemin vers l'emploi du temps (" + e.getLocalizedMessage() + ")", Toast.LENGTH_LONG).show();
                    webView.loadUrl(HomeFragment.AURIONURL, getHeaders());
                });
            }

        }
    }

    @Override
    public void preload() {
        if(!failed){
            webView.loadUrl(AURION_CAL_URL, getHeaders());
        }
    }
}