package fr.nitorac.aurionweb.security;

import android.content.Context;
import android.os.Build;

import java.io.IOException;
import java.security.GeneralSecurityException;

import fr.nitorac.aurionweb.StorageManager;
import fr.nitorac.aurionweb.aurionweb.AurionCred;

/**
 * On utilise une méthode assez compliquée pour stocker le mot de passe Aurionweb
 *
 * Etant donné qu'on ne peut utiliser une clé de chiffrement dans le code car trop facilement retrouvable,
 * on la stocke en utilisant le chiffrement fourni par Android !
 *
 * Cependant, le gestionnaire de chiffrement Android a changé d'API avant et après Android M, il faut donc gérer les deux possibilités
 */
public class SecurityManager {

    public static final String KEYSTORE_NAME = "NitAurionWeb";
    public static final String ENCRYPT_KEY = "aesKey";

    private static SecurityHelper secHelp;

    public static AurionCred creds;

    public static void loadSavedCreds(Context c) throws GeneralSecurityException, IOException {
        creds = StorageManager.getInstance().getCreds(c);
        if(creds == null){
            creds = new AurionCred();
        }
    }

    public static SecurityHelper getSecurityHelper(Context c) throws GeneralSecurityException, IOException {
        if(secHelp == null) {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                secHelp = new SecurityHelperPostM();
            }else{
                secHelp = new SecurityHelperPreM(c);
            }
        }
        return secHelp;
    }
}
